__revision__ = "/home/scons/scons/branch.0/branch.96/baseline/src/engine/SCons/Options/BoolOption.py 0.96.91.D001 2005/09/08 09:14:36 knight"
__all__ = ('BoolOption', 'True', 'False')
import string
import SCons.Errors
__true_strings  = ('y', 'yes', 'true', 't', '1', 'on' , 'all' )
__false_strings = ('n', 'no', 'false', 'f', '0', 'off', 'none')
True, False = 1, 0
def _text2bool(val):
    lval = string.lower(val)
    if lval in __true_strings: return True
    if lval in __false_strings: return False
    raise ValueError("Invalid value for boolean option: %s" % val)
def _validator(key, val, env):
    if not env[key] in (True, False):
        raise SCons.Errors.UserError('Invalid value for boolean option %s: %s' % (key, env[key]))
def BoolOption(key, help, default):
    return (key, '%s (yes|no)' % help, default, _validator, _text2bool)
