__revision__ = "/home/scons/scons/branch.0/branch.96/baseline/src/engine/SCons/Options/PathOption.py 0.96.91.D001 2005/09/08 09:14:36 knight"
import os
import os.path
import SCons.Errors
class _PathOptionClass:
    def PathAccept(self, key, val, env):
        pass
    def PathIsDir(self, key, val, env):
        if not os.path.isdir(val):
            if os.path.isfile(val): m = 'Directory path for option %s is a file: %s'
            else: m = 'Directory path for option %s does not exist: %s'
            raise SCons.Errors.UserError(m % (key, val))
    def PathIsDirCreate(self, key, val, env):
        if os.path.isfile(val):
            m = 'Path for option %s is a file, not a directory: %s'
            raise SCons.Errors.UserError(m % (key, val))
        if not os.path.isdir(val): os.makedirs(val)
    def PathIsFile(self, key, val, env):
        if not os.path.isfile(val):
            if os.path.isdir(val): m = 'File path for option %s is a directory: %s'
            else: m = 'File path for option %s does not exist: %s'
            raise SCons.Errors.UserError(m % (key, val))
    def PathExists(self, key, val, env):
        if not os.path.exists(val):
            m = 'Path for option %s does not exist: %s'
            raise SCons.Errors.UserError(m % (key, val))
    def __call__(self, key, help, default, validator=None):
        if validator is None: validator = self.PathExists
        return (key, '%s ( /path/to/%s )' % (help, key), default, validator, None)
PathOption = _PathOptionClass()
